!c Description:
!c  ǮѲ뵤νͤ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-03-01    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_initmol
  interface
     
     subroutine initmol(emol, struct, mol, mol_ini)
       real(8), intent(in)                :: emol(:)   
       real(8), intent(in)                :: struct(:,:) 
       real(8), intent(in), optional      :: mol_ini(:)  
       real(8), intent(out), allocatable  :: mol(:)  
     end subroutine initmol
     
  end interface
end module interface_initmol




subroutine initmol(emol, struct, mol, mol_ini)
  use ssl2_linear
  use interface_display
  use prm_common, only: zero, debug
  
  implicit none
  real(8), intent(in)                :: emol(:)   
  real(8), intent(in)                :: struct(:,:) 
  real(8), intent(in), optional      :: mol_ini(:)  
  real(8), intent(out), allocatable  :: mol(:)  
  
  real(8), parameter     :: factor = 1.0d-1
  real(8), allocatable   :: A(:,:)
  real(8), allocatable   :: B(:)
  real(8), allocatable   :: emol_tmp(:)
  integer                :: i, e
  integer                :: N, M, num
  integer, allocatable   :: order(:)
  

  N = size(struct, 1)
  M = size(struct, 2)
  num = 1
  allocate(A(M, M), B(M), order(M), mol(N), emol_tmp(M))
  order = 0
  mol = 0.0d0
  
  
!!!
!!!κ
!!!
  do e = 1, M
     
     use: do i = 1, N
        if (struct(i, e) >= 1 .AND. .not. any(order == i)) then 
           A(num, :) = struct(i, :)
           order(e) = i
           exit use
        end if
     end do use
     
     num = num + 1
  end do

  !žֹѴ
  A = transpose(A)
!  if (debug) call display(A, "A")
  
  
!!!
!!!˻Ȥʤäؼ¸̤ŬͿ
!!!
  not_use: do i = 1, N
     if (any(order == i)) cycle not_use
     
     emol_tmp =  emol / struct(i, :) 
     num = minloc(emol_tmp, 1, emol_tmp > 0.0d0)
     
     mol(i) = (emol(num) * factor) / struct(i, num)
     
     if (present(mol_ini) .AND. mol_ini(i) > zero) then 
        mol(i) = mol_ini(i)
     end if
  end do not_use
  

!!!
!!!κ. ǥ뤫嵭Ϳʬθ̤򺹤
!!!
  LOOP: do
     do e = 1, M
        B(e) = emol(e) - dot_product(struct(:, e), mol)
     end do
     
     !⤷ B ˤʤäʤ, mol Ŭʥե򤫤
     !ϱդΥ¸뤿, mol ե. 
     if (minval(B) > 0.0d0) then 
        exit LOOP
     else
        mol = mol * 9.0d-1
     end if
  end do LOOP
!  if (debug) call display(B, "B")
  
  
!!!
!!!󼰤, Ĥβؼ¸̤
!!!
  call ssl2_lax_init(M)
  call ssl2_lax(A, B)

  do e = 1, M
     mol(order(e)) = B(e)
  end do


!!!
!!!ͤˤʤäƤʤɤΥå
!!!  
  if (minval(mol) < 0.0d0) then 
     write(*,*) "ERROR, initmol.f90: mol < 0.0"
     write(*,*) mol
     stop
  end if


!!!
!!!夫Ť
!!!
  deallocate(A, B, emol_tmp, order)

end subroutine Initmol


